isNS4 = (document.layers) ? true : false;
isIE4 = (document.all && !document.getElementById) ? true : false;
isIE5 = (document.all && document.getElementById) ? true : false;
isNS6 = (!document.all && document.getElementById) ? true : false;


function setCookieTemp(name, value) {
	document.cookie = name + "=" + escape(value);
}

function getCookie(Name) {
	var search = Name + "=";
	if (document.cookie.length > 0) { // if there are any cookies
		offset = document.cookie.indexOf(search) ;
		if (offset != -1) { // if cookie exists 
			offset += search.length ;
			// set index of beginning of value
			end = document.cookie.indexOf(";", offset) ;
			// set index of end of cookie value
			if (end == -1) end = document.cookie.length;
			return unescape(document.cookie.substring(offset, end));
		} 
	}
	return new String("");
}


//***************************************
// Function for up.jsp
function setSearch(value){
	setCookieTemp("JSB_SEARCH", value);
}

function getSearch(){
	return getCookie("JSB_SEARCH");
}

function setSubDirs(){
	if (getSubDirs()=="checked"){
		setCookieTemp("JSB_SUBDIRS", "unchecked");
	}
	else {		
		setCookieTemp("JSB_SUBDIRS", "checked");
	}
}

function getSubDirs(){
	var s=getCookie("JSB_SUBDIRS");
	if ("null"+s=="null"){
		setCookieTemp("JSB_SUBDIRS", "checked");		
		return "checked";
	}
	else{
		return s;
	}
}

function setMatchCase(){
	if (getMatchCase()=="checked"){
		setCookieTemp("JSB_MATCHCASE", "unchecked");
	}
	else {				
		setCookieTemp("JSB_MATCHCASE", "checked");
	}
}

function getMatchCase(){
	var s=getCookie("JSB_MATCHCASE");
	if ("null"+s=="null"){
		setCookieTemp("JSB_MATCHCASE", "checked");		
		return "checked";
	}
	else{
		return s;
	}
}
// Function for up.jsp
//***************************************



//***************************************
// Function for current.jsp
function setSearchCurrent(value){
	setCookieTemp("JSB_CURRENT_SEARCH", value);
}

function getSearchCurrent(){
	return getCookie("JSB_CURRENT_SEARCH");
}
// Function for current.jsp
//***************************************



//************************
// Function for the all menus
function getMenuObj(menuName, msg){
	if (isIE4 || isIE5 || isNS6){
		menuStr="parent.frames.CENTER.document.getElementById('"+menuName+"')";
	}
	else if (isNS4) {
		menuStr="parent.CENTER.document."+menuName;
	}
	menuObject = eval(menuStr);
	var undef;	
	if ((isNS4 && typeof menuObject == "undefined") ||
		(isIE5 && menuObject == undef) ||
		(isNS6 && menuObject == null) ) {
			if (msg == "true"){
				alert("Please wait, the file must be fully loaded to use this option.");
			}
		return null;
	}
	return menuObject;
}

function activeMenu(menuName){
	menuObject=getMenuObj(menuName, "true");
	if (menuObject == null) return;

	if (isIE4 || isIE5  || isNS6){
		if (menuObject.style.visibility=="visible" ){
			hideMenu(menuObject);
		}
		else{
			showMenu(menuObject);
		}	
	}
	else if (isNS4) {
		if (menuObject.visibility=="hide" ){
			showMenu(menuObject);
		}
		else{
			hideMenu(menuObject);
		}
	}
}

function showMenu(menuObject){
	hideAllMenu();	
	if (isIE4 || isIE5  || isNS6){
		menuObject.style.visibility="visible"
	}
	else if (isNS4) {
		menuObject.visibility="show"
	}
	redirectToMenu();
}

function redirectToMenu(){
	var url=parent.CENTER.location.href;
	var end=url.indexOf("#");
	if (end!=-1){
    	url=url.substring(0, end);
    }
	parent.CENTER.window.location=url+"#JSBrowser_menu";
}

function hideMenu(menuObject){
	if (isIE4 || isIE5  || isNS6){
		menuObject.style.visibility="hidden"
	}
	else if (isNS4) {
		menuObject.visibility="hidden"
	}
}

function hideAllMenu(){
	menuObject = getMenuObj('cssAllMethodsMenu', "false");
	if (menuObject != null) hideMenu(menuObject);
	menuObject = getMenuObj('cssFileMenu', "false");
	if (menuObject != null) hideMenu(menuObject);	
	menuObject = getMenuObj('cssViewMenu', "false");
	if (menuObject != null) hideMenu(menuObject);	
	menuObject = getMenuObj('selectionMenu', "false");
	if (menuObject != null) hideSelectionMenu(menuObject);
}
// Function for the all menus
//************************


//************************
// Function for the BrowserWaiting
function setWaitingInternal(waitingMsg){
	if (isNS4){
	   elm = document.layers["waiting2Netscape"];
	}
	else if (isIE4) {
	   elm = document.all["waiting2"];
	}
	else if (isIE5 || isNS6){
		elm = document.getElementById("waiting2");
	}

	if (isIE5 || isNS6){
		elm.innerHTML=waitingMsg;
	}
	else if (isIE4 || isNS4) {
		// don't work
	}
}
function setWaiting(waitingMsg){
	setTimeout('setWaitingInternal("'+waitingMsg+'")', 1);
}
// Function for the BrowserWaiting
//************************



//************************
// Contextual menu functions
function displaySelectionMenu(){
	initSelectedText()
	if (selectedText==""){
		return true;
	}
					
	//Find out how close the mouse is to the corner of the window
	var rightedge=document.body.clientWidth-event.clientX
	var bottomedge=document.body.clientHeight-event.clientY
	
	//if the horizontal distance isn't enough to accomodate the width of the context menu
	if (rightedge<selectionMenu.offsetWidth)
	//move the horizontal position of the menu to the left by it's width
		selectionMenu.style.left=document.body.scrollLeft+event.clientX-selectionMenu.offsetWidth
	else
	//position the horizontal position of the menu where the mouse was clicked
		selectionMenu.style.left=document.body.scrollLeft+event.clientX
	
	//same concept with the vertical position
	if (bottomedge<selectionMenu.offsetHeight)
		selectionMenu.style.top=document.body.scrollTop+event.clientY-selectionMenu.offsetHeight
	else
		selectionMenu.style.top=document.body.scrollTop+event.clientY
	
	selectionMenu.style.visibility="visible"
	
	return false
}

function hideSelectionMenu(menuObject){
	parent.frames.CENTER.document.oncontextmenu=displaySelectionMenu
	menuObject.style.visibility="hidden"
}

function enableSelectionMenu(){
	if (event.srcElement.className=="selectionMenuItemStyle"){
		event.srcElement.style.backgroundColor="highlight"
		event.srcElement.style.color="white"
		window.status=event.srcElement.innerHTML + ": " + selectedText1Line
	}
}

function disableSelectionMenu(){
	if (event.srcElement.className=="selectionMenuItemStyle"){
		event.srcElement.style.backgroundColor=""
		event.srcElement.style.color="black"
		window.status=''
	}
}

function menuItemSelected(){
	if (event.srcElement.className=="selectionMenuItemStyle"){
		eval(event.srcElement.getAttribute("exec"))
	}
}

function initSelectedText()
{
	if (document.selection){
		txt = document.selection.createRange().text;
	}
	else if (document.getSelection){
		txt = document.getSelection();
	}
	else {
		return "";
	}
	selectedText=txt;
	selectedText1Line=txt.replace(new RegExp('([\\f\\n\\r\\t\\v ])+', 'g')," ");
}

function searchLocal(){
	if (selectedText!=""){
		setSearchCurrent(selectedText1Line);			
		parent.CURRENT.document.currentSearch.Arg1.value=selectedText1Line;
		parent.CURRENT.document.currentSearch.submit();
	}
}

function searchInPackage(reload){
	if (selectedText!=""){
		setSearch(selectedText1Line);
		setSearchCurrent("");
		parent.CURRENT.location=reload+"&Arg1="+selectedText1Line;
		parent.UP.location.reload();		
	}
}

function copy(){
	if (selectedText!=""){
		window.clipboardData.setData("Text",selectedText);
	}
}	
// Contextual menu functions
//************************



//************************
// Function for the report
function setReportLineNumber(){
	if (getReportLineNumber()=="checked"){
		setCookieTemp("JSB_REPORT_LINE_NUMBER", "unchecked");
	}
	else {		
		setCookieTemp("JSB_REPORT_LINE_NUMBER", "checked");
	}
}

function getReportLineNumber(){	
	var s=getCookie("JSB_REPORT_LINE_NUMBER");
	if ("null"+s=="null"){		
		setCookieTemp("JSB_REPORT_LINE_NUMBER", "unchecked");		
		return "unchecked";
	}
	else{		
		return s;
	}
}
// Function for the report
//************************
